
package net.javainthebox.flickrviewer;

import javafx.data.pull.Event;
import javafx.data.pull.PullParser;
import javafx.data.xml.QName;
import javafx.io.http.HttpRequest;

import java.io.InputStream;
import java.lang.Exception;
import java.net.URLEncoder;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.swing.SwingWorker;
 
public class AtomReadWorker extends SwingWorker {
    public-init var url: String;
    public-init var thumbnailPane: ThumbnailPane;

    // TlCURLo߂̐K\
    def pattern = java.util.regex.Pattern.compile("http://farm.*_m.jpg");

    // 񓯊ɍs鏈
    public override function doInBackground(): Object {
        // HTTPʐMs
        var request = HttpRequest {
            location: url
                    
            onInput: parseAtom;

            onException: function(ex: Exception) {
                println("exception: {ex.getMessage()}");
            }
        };
        request.enqueue();
    }

    // Atom̃p[X
    function parseAtom(stream: InputStream) {
        var thumbnail: Thumbnail;
        var inEntry: Boolean;

        var parser = PullParser {
            documentType: PullParser.XML;
            input: stream

            onEvent: function(event: Event) {
                if (event.type == PullParser.START_ELEMENT) {
                    if (event.qname.name == "entry") {
                        // <entry>̊Jn
                        // VThumbnailIuWFNg𐶐
                        inEntry = true;
                        thumbnail = Thumbnail {};
                    }
                }
                if (event.type == PullParser.END_ELEMENT) {
                    if (event.qname.name == "entry") {
                        // </entry>̏ꍇ
                        // 쐬ThumbnailIuWFNgCxgfBXpb`Xbh
                        // 擾ł悤ɁApublish
                       inEntry = false;
                        this.publish(thumbnail as Object);
                    } else if (inEntry and event.qname.name == "title") {
                        // </title>̏ꍇ
                        // ThumbnailIuWFNgtitleݒ
                        thumbnail.title = event.text;
                    } else if (inEntry and event.qname.name == "content") {
                        // </content>̏ꍇ
                        // K\pāATlCURLoA
                        // thumbnailUrlɐݒ
                        var matcher = pattern.matcher(event.text);
                        if (matcher.find()) {
                            var url = matcher.group();
                            thumbnail.thumbnailUrl = url.replaceAll("_m", "_t");
                            // 傫C[WURL쐬
                            thumbnail.imageUrl = url.replaceAll("_m", "");
                        }
                    }
                }
            }
        }
        // p[X̊Jn
        parser.parse();
    
        stream.close();
    }

    // CxgfBXpb`Xbhŏ֐
    // publishꂽIuWFNgƂȂ
    override function process(thumbnails: List) {
        for (thumbnail in thumbnails) {
            insert thumbnail as Thumbnail into thumbnailPane.thumbnails;
        }
    }
}