
package net.javainthebox.flickrviewer;

import javafx.scene.Scene;
import javafx.scene.paint.Color;
import javafx.stage.Stage;

var imagePane = ImagePane {
    translateX: 120
}
var thumbnailPane = ThumbnailPane {
    update: imagePane.update
}

var reader = AtomReadWorker {
    url: "http://api.flickr.com/services/feeds/photos_public.gne?id=57085156@N00&lang=en-us&format=atom"
    thumbnailPane: thumbnailPane
}
reader.execute();

Stage {
    title: "Flickr Searcher"
    scene: Scene {
        width: 660
        height: 660
        fill: Color.BLACK

        content: [
            imagePane,
            thumbnailPane
        ]
    }
}